<?php
/**
*
* @package National Flags
* @version $Id: falg_users.php
* @copyright (c) Rich McGirr http://rmcgirr83.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);

$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_flag.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('memberlist');
$user->add_lang('mods/info_acp_flags');

// Flags enabled?
if (!$config['allow_flags'])
{
	trigger_error('FLAG_DISABLED');
}

$mode = request_var('mode', '');
// Check our mode...
if (!in_array($mode, array('', 'flags')))
{
	trigger_error('NO_MODE');
}
switch ($mode)
{
	// display all flags and user count
	case 'flags':
		//let's get the flags
		$sql = 'SELECT f.flag_id, f.flag_name, f.flag_image, COUNT(u.user_flag) as user_count
			FROM ' . FLAGS_DATA_TABLE . ' f
			LEFT JOIN ' . USERS_TABLE . " u on f.flag_id = u.user_flag
		WHERE u.user_type IN (" . USER_NORMAL . ', ' . USER_FOUNDER . ") AND u.user_flag > 0
		GROUP BY f.flag_id
		ORDER BY user_count DESC, f.flag_name ASC";
		$result = $db->sql_query($sql);

		$flags = array();
		$countries = $users_count = 0;
		while ($row = $db->sql_fetchrow($result))
		{
			++$countries;
			$flag_id = $row['flag_id'];
			$user_count = $row['user_count'];
			$users_count = $users_count + $user_count;
			$flag_users = $user_count == 1 ? 'user' : 'users';
			$flags[] = '<a href="' . append_sid("{$phpbb_root_path}flag_users.$phpEx", 'fid=' . (int) $flag_id) . '">' . get_user_flag($flag_id) . '</a> ' . number_format($user_count) . ' ' . $flag_users;
		}
		$db->sql_freeresult($result);

		$flags_list = $flags;
		$flags_list_m = array();
		$flags_list_str = '';
		$flags_list_m = $flags_list;
		$f_list = count($flags_list);
		if ($f_list)
		{
			$rows = ceil (round($f_list / 10));
			if ($rows < 1)
			{
				$rows = 1;
			}
			$flags_list_m = array_chunk($flags_list_m, $rows);
			
			$flags_list_str .= '<div style="float:left;text-align:left;margin-left:5px;">';
			$flags_list_str .= (string) implode('<br />', $flags_list_m[0]);
			$flags_list_str .= '</div>';
			for ($i=1; $i*$rows < $f_list; $i++)
			{
				$flags_list_str .= '<div style="float:left;text-align:left;margin-left:5px;">';		
				$flags_list_str .= (string) implode('<br />', $flags_list_m[$i]);
				$flags_list_str .= '</div>';	
			}
			$flags_list = $flags_list_str;
		}
		$template->assign_vars(array(
			'FLAGS'		=> true,
			'COUNTRIES'	=> $countries . ' ' . $user->lang['FLAGS'] . '&nbsp;&nbsp;' . $users_count . ' ' . $user->lang['USERS'],
			'FLAGS_LIST' => $flags_list
		));			
	break;
	
	default:
		
		$fid = request_var('fid', 0);
		$start = request_var('start', 0);
		//let's get the flag requested
		$sql = 'SELECT flag_id, flag_name, flag_image
			FROM ' . FLAGS_DATA_TABLE . '
			WHERE flag_id = ' .(int) $fid;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if (!$row)
		{
			trigger_error('NO_USER_HAS_FLAG');
		}
		
		$flag = get_user_flag($row['flag_id']) . '&nbsp;' . $row['flag_name'];

		$template->assign_vars(array(
			'FLAG'	=> $flag,
			'S_VIEWONLINE'	=> $auth->acl_get('u_viewonline'),
		));

		// set sorting options
		$default_key = 'c';
		$sort_key = request_var('sk', $default_key);
		$sort_dir = request_var('sd', 'a');

		// following shamelessly stolen from memberlist.php
		// Sorting
		$sort_key_text = array('a' => $user->lang['SORT_USERNAME'], 'b' => $user->lang['SORT_LOCATION'], 'c' => $user->lang['SORT_JOINED'], 'd' => $user->lang['SORT_POST_COUNT'], 'f' => $user->lang['WEBSITE']);
		$sort_key_sql = array('a' => 'username_clean', 'b' => 'user_from', 'c' => 'user_regdate', 'd' => 'user_posts', 'f' => 'user_website');

		if ($auth->acl_get('u_viewonline'))
		{
			$sort_key_text['l'] = $user->lang['SORT_LAST_ACTIVE'];
			$sort_key_sql['l'] = 'user_lastvisit';
		}

		$sort_dir_text = array('a' => $user->lang['ASCENDING'], 'd' => $user->lang['DESCENDING']);
		$s_sort_key = '';
		foreach ($sort_key_text as $key => $value)
		{
			$selected = ($sort_key == $key) ? ' selected="selected"' : '';
			$s_sort_key .= '<option value="' . $key . '"' . $selected . '>' . $value . '</option>';
		}

		$s_sort_dir = '';
		foreach ($sort_dir_text as $key => $value)
		{
			$selected = ($sort_dir == $key) ? ' selected="selected"' : '';
			$s_sort_dir .= '<option value="' . $key . '"' . $selected . '>' . $value . '</option>';
		}

		// initialize $first_char...others are below
		$first_char = request_var('first_char', '');

		$sql_where = ' WHERE user_flag = ' . (int) $fid;

		if ($first_char == 'other')
		{
			for ($i = 97; $i < 123; $i++)
			{
				$sql_where .= ' AND username_clean NOT ' . $db->sql_like_expression(chr($i) . $db->any_char);
			}
		}
		else if ($first_char)
		{
			$sql_where .= ' AND username_clean ' . $db->sql_like_expression(substr($first_char, 0, 1) . $db->any_char);
		}

		// Sorting and order
		if (!isset($sort_key_sql[$sort_key]))
		{
			$sort_key = $default_key;
		}

		$order_by = $sort_key_sql[$sort_key] . ' ' . (($sort_dir == 'a') ? 'ASC' : 'DESC');

		// Build a relevant pagination_url
		$params = $sort_params = array();

		// We do not use request_var() here directly to save some calls (not all variables are set)
		$check_params = array(
			'sk'			=> array('sk', $default_key),
			'sd'			=> array('sd', 'a'),
			'first_char'	=> array('first_char', ''),
			'fid'			=> array('fid', 0),
			'mode'			=> array('mode', ''),
		);
		$u_first_char_params = array();
		foreach ($check_params as $key => $call)
		{
			if (!isset($_REQUEST[$key]))
			{
				continue;
			}

			$param = call_user_func_array('request_var', $call);
			$param = urlencode($key) . '=' . ((is_string($param)) ? urlencode($param) : $param);
			
			$params[] = $param;
			if ($key != 'first_char')
			{
				$u_first_char_params[] = $param;
			}
			if ($key != 'sk' && $key != 'sd')
			{
				$sort_params[] = $param;
			}
		}

		$pagination_url = append_sid("{$phpbb_root_path}flag_users.$phpEx", implode('&amp;', $params));
		$sort_url = append_sid("{$phpbb_root_path}flag_users.$phpEx", implode('&amp;', $sort_params));
		
		unset($params, $sort_params);
		$u_first_char_params = implode('&amp;', $u_first_char_params);
		$u_first_char_params .= ($u_first_char_params) ? '&amp;' : '';

		$first_characters = array();
		$first_characters[''] = $user->lang['ALL'];
		for ($i = 97; $i < 123; $i++)
		{
			$first_characters[chr($i)] = chr($i - 32);
		}
		$first_characters['other'] = $user->lang['OTHER'];

		foreach ($first_characters as $char => $desc)
		{
			$template->assign_block_vars('first_char', array(
				'DESC'			=> $desc,
				'VALUE'			=> $char,
				'S_SELECTED'	=> ($first_char == $char) ? true : false,
				'U_SORT'		=> append_sid("{$phpbb_root_path}flag_users.$phpEx", $u_first_char_params . 'first_char=' . $char) . '#flagusers',
			));
		}

		$template->assign_vars(array(
			'S_SORT_OPTIONS'		=> $s_sort_key
		));
		// end of thievery
		// now users that have that flag
		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			 ' . $sql_where . '
				AND ' . $db->sql_in_set ('user_type', array(USER_NORMAL, USER_FOUNDER)) . '
			ORDER BY ' . $order_by;
		$result = $db->sql_query_limit($sql, $config['topics_per_page'], $start);
		$rows = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);
		
		// for counting of flag users
		$result = $db->sql_query($sql);
		$row2 = $db->sql_fetchrowset($result);
		$total_users = (int) count($row2);
		$db->sql_freeresult($result);
		unset($row2);

		foreach($rows as $row)
		{
			$user_id = $row['user_id'];
			
			$username = $auth->acl_get('u_viewprofile') ? get_username_string('full', $user_id, $row['username'], $row['user_colour']) : get_username_string('no_profile', $user_id, $row['username'], $row['user_colour']);

			$template->assign_block_vars('user_row', array(
				'JOINED'		=> $user->format_date($row['user_regdate']),
				'VISITED'		=> (empty($row['user_lastvisit'])) ? ' - ' : $user->format_date($row['user_lastvisit']),
				'POSTS'			=> ($row['user_posts']) ? $row['user_posts'] : 0,
				'LOCATION'		=> ($row['user_from']) ? $row['user_from'] : '',
				'WEBSITE'		=> (!empty($row['user_website'])) ? $row['user_website'] : '',
				'SHORT_WEBSITE'	=> (!empty($row['user_website'])) ? ((strlen($row['user_website']) > 35) ? substr($row['user_website'], 0, 19) . ' ... ' . substr($row['user_website'], -10) : $row['user_website']) : '',
				'USERNAME_FULL'		=> $username,
				'U_SEARCH_USER'		=> ($auth->acl_get('u_search')) ? append_sid("{$phpbb_root_path}search.$phpEx", "author_id=$user_id&amp;sr=posts") : '',
			));
		}
		$db->sql_freeresult($result);

		// Page list function...
		$template->assign_vars(array(
			'USER_FLAGS'		=> true,
			'PAGE_NUMBER'		=> on_page($total_users, (int) $config['topics_per_page'], $start),
			'TOTAL_USERS'		=> ($total_users <> 1) ? sprintf($user->lang['FLAG_USERS'], $total_users) : sprintf($user->lang['FLAG_USER'], $total_users),
			'PAGINATION'		=> generate_pagination($pagination_url, $total_users, $config['topics_per_page'], $start),
			'U_SORT_USERNAME'		=> $sort_url . '&amp;sk=a&amp;sd=' . (($sort_key == 'a' && $sort_dir == 'a') ? 'd' : 'a'),
			'U_SORT_JOINED'			=> $sort_url . '&amp;sk=c&amp;sd=' . (($sort_key == 'c' && $sort_dir == 'a') ? 'd' : 'a'),
			'U_SORT_POSTS'			=> $sort_url . '&amp;sk=d&amp;sd=' . (($sort_key == 'd' && $sort_dir == 'a') ? 'd' : 'a'),
			'U_SORT_WEBSITE'		=> $sort_url . '&amp;sk=f&amp;sd=' . (($sort_key == 'f' && $sort_dir == 'a') ? 'd' : 'a'),
			'U_SORT_LOCATION'		=> $sort_url . '&amp;sk=b&amp;sd=' . (($sort_key == 'b' && $sort_dir == 'a') ? 'd' : 'a'),
			'U_SORT_ACTIVE'			=> ($auth->acl_get('u_viewonline')) ? $sort_url . '&amp;sk=l&amp;sd=' . (($sort_key == 'l' && $sort_dir == 'a') ? 'd' : 'a') : '',
			'U_LIST_CHAR'			=> $sort_url . '&amp;sk=a&amp;sd=' . (($sort_key == 'l' && $sort_dir == 'a') ? 'd' : 'a'),
			'S_MODE_SELECT'		=> $s_sort_key,
			'S_ORDER_SELECT'	=> $s_sort_dir,
			'S_MODE_ACTION'		=> $pagination_url)
		);	
	break;	
}

// Output the page
$page_title = $user->lang['USER_FLAGS'];
page_header($page_title, false);
	
$template->set_filenames(array(
	'body' => 'flag_users_body.html'
));

// jumpbox?   sure why not
make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));
	
page_footer();

?>